Attribute VB_Name = "ErrorMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################

'''''''''''''''''''''''''''''''''''''''''
'Error Handler Module
'Last Modified on 2 November 2002
'''''''''''''''''''''''''''''''''''''''''
Option Explicit

Private Const ErrHname = "ALIMbot Error Control"
Private Const ErrHFile = "\error.txt"

Public Enum ErrValues
eFileOpenErrorOk
eFileOpenErrorCritical
eBasicDataFilePathNotSet
eAMCDiectoryPathNotSet
eOutputTypeNotSet
eMaxStarOverflow
End Enum

Function ErrH(ByVal Err_No As Integer, ByVal Err_Info As String)
Dim Err_Msg As String
Dim arrerr(5) As String
Dim fileno As Integer

'Array containing Error Definitions
arrerr(eFileOpenErrorOk) = "File Not Found."
arrerr(eFileOpenErrorCritical) = "File Not Found is critically required."
arrerr(eBasicDataFilePathNotSet) = "Basic data file path not set."
arrerr(eAMCDiectoryPathNotSet) = "AMC Directory path not set."
arrerr(eOutputTypeNotSet) = "OutputType is set improperly." & vbNewLine & _
                            "0 for plain text" & vbNewLine & _
                            "1 for RTF" & vbNewLine & _
                            "2 for HTML" & vbNewLine & _
                            "Using Default as 0"
arrerr(eMaxStarOverflow) = "Stars (*) Overflow."

'End if Error Definitions

'Generate Error Message
Err_Msg = Date & " (" & Time & ") : ErrNo " & Err_No & " : " & arrerr(Err_No) & _
          vbNewLine & "Details: " & Err_Info

'Write Error to File
fileno = FreeFile
Open App.Path & ErrHFile For Append As #fileno
    'MsgBox err_msg, vbInformation, ErrHname
    Print #fileno, Err_Msg
Close

'Don't continue if it a critical error
If Err_No = eFileOpenErrorCritical Then
    Err_Msg = "Error No: " & Err_No & vbNewLine & vbNewLine & _
                "For details check" & vbNewLine & _
                App.Path & ErrHFile
    MsgBox Err_Msg, vbCritical, ErrHname & " :  " & "Critical Error"
End If

End Function
