Attribute VB_Name = "GetAnswerMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
Option Explicit

Function GetResponse(strin As String) As String
Dim arrstr() As String
Dim temp As String
Dim Answer As String
Dim i As Integer
Dim r, oldr, anscount As Integer
Dim original_strin As String
Dim fileno As Integer
Dim filen As String
Dim strmatch As String
Dim rawTopic, key As String

'-----------------
'Empty Existing option file
fileno = FreeFile
Open VariablesMod.OPTIONFILE For Output As #fileno
    Print #fileno, ""
Close #fileno
'------------------

'Do pre-processing on input string
strin = DoRemoveMultipleSpaces(strin)
strin = DoReplaceInput(strin)
strin = DoReplaceQuestion(strin)
original_strin = strin 'only replace multiple white spaces and leave original string as it is
strin = DoDeleteWords(strin)
strin = DoRemovePunctuation(strin)
'DoSpellCheck (strin)
'End of pre-processing on input string

'=====================================================
'Search for answer
Call SearchInFile(VariablesMod.CONFIGDATAFILE, strin)

'then search in User MEMory file
'make sure the file is present before
filen = VariablesMod.AMCDIR & VariablesMod.USERNAME & ".mem"
Call SearchInFile(filen, strin)

'=====================================================

'Get answer with best relevance from option.tmp file
'Find how many answers are available
fileno = FreeFile
Open VariablesMod.OPTIONFILE For Input As fileno
    anscount = 0
    While Not EOF(fileno)
        Line Input #fileno, temp
        If Not IsEmpty(Trim(temp)) Then
            anscount = anscount + 1
        End If
    Wend
Close #fileno
'--------------------
Answer = "" 'initialize
strmatch = "" 'initialize

If Not anscount = 0 Then
    fileno = FreeFile
    Open VariablesMod.OPTIONFILE For Input As #fileno
    oldr = 999
    r = 0
        While Not EOF(fileno)
            Line Input #fileno, temp
            If Not temp = "" Then
                arrstr = Split(temp, "##")
                r = Int(Trim(arrstr(0)))
                'MsgBox r & " " & oldr
                If r >= oldr Then
                    'Check if more than one answers are avalaible
                    '5001 means answer is from response:failure in keywordvariable tag
                    'then decrease the relevance level to lowest or last..
                    If anscount > 1 And oldr > 999 Then 'And IsEmpty(Answer) Then
                        If r > 2100 And r < 2106 Then r = oldr 'this means that for this condition keyword will be ranked higher than keywordstart
                        If r = 5001 Then r = oldr
                    End If
                    
                    If r = oldr Then
                        Answer = Answer
                        rawTopic = rawTopic
                        key = key
                    Else 'if r is still > oldr then
                        Answer = arrstr(2)
                        rawTopic = arrstr(5)
                        key = arrstr(3)
                        strmatch = arrstr(4) 'the pattern that matched
                    End If
                    oldr = r
                   ' MsgBox Answer
                End If
            End If
           Wend
    Close #fileno
    pCurrChatTopic = FindCurrTopic(rawTopic, strin, key, strmatch)
Else
    pCurrChatTopic = FindCurrTopic("", strin, "", "") 'if no answer is found in dat file
End If

'if still there is no answer then check if input is repeated
If VariablesMod.LASTINPUT = original_strin Then
    Answer = GetAnswerFromKeyTag("[repetition]")
End If

'if user input is very less and there is no answer
If Answer = "" And Len(strin) < 15 Then
    Answer = GetAnswerFromKeyTag("[askformoreinfo]")
End If

'if still there is no answer
If Answer = "" Then
    Answer = GetAnswerFromKeyTag("[dead]")
End If

'Check if the answer is same this time too
If VariablesMod.LASTRESPONSE = Answer Then
    Answer = "I already told you!"
End If

'Replace all %variables
'Before Returning the reply
Answer = DoPostProcessing(original_strin, Answer, strmatch, pCurrChatTopic)
'---------------------------
'Store Chat information
VariablesMod.LASTINPUT = original_strin
VariablesMod.LASTRESPONSE = Answer
Call AppendToCurrChatFile(Answer, original_strin)

GetResponse = Answer
End Function


Function SearchInFile(ByVal filen As String, ByVal strin As String)
Dim Qkey As String 'whether keywordvariable, keywordonly, keywordlist etc
Dim Qkeyarr() As String 'left and right contents of keywordvariable, keywordonly tags
Dim temp As String
Dim startchr As String
Dim fileno As Integer
Dim newAnswer As String
Dim eError As Boolean
fileno = FreeFile
'Start Searching the Database
eError = True
On Error GoTo Fend
Open filen For Input As #fileno

While Not EOF(fileno)
    Line Input #fileno, temp
    temp = Trim(temp)
    startchr = Left(temp, 1) 'Get the First Character in the line
        
    Select Case startchr
    Case "#"
        'Do Nothing. Negelect line which is a comment
    Case "["
        Qkey = Mid(temp, 2, Len(temp) - 2) 'Remove [ ] braces
        ''''''''''''''''''''''''''''''''''''''''''''''''
        Qkeyarr = Split(Qkey, ":")
        Select Case Qkeyarr(0)
            Case "keywordvariable"
                newAnswer = AnalyseKeywordvariable(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "keywordlistorder"
                newAnswer = AnalyseKeywords(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "keywordlist"
                newAnswer = AnalyseKeywords(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "keywordonly"
                newAnswer = AnalyseKeywords(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "keywordstart"
                newAnswer = AnalyseKeywords(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "keyword"
                newAnswer = AnalyseKeywords(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case "kp"
                'newAnswer = NewAnalyzer(Qkeyarr(0), Qkeyarr(1), strin, filen)
            Case Default
        End Select
        ''''''''''''''''''''''''''''''''''''''''''''''''
    Case Default
        'Go ahead
    End Select
Wend
Close #fileno
eError = False

Fend:
If eError = True Then
    Call ErrH(eFileOpenErrorOk, filen)
End If
End Function
''''''''''''
'Analyses strin with the Keywordvariable tag
''''''''''''
Function AnalyseKeywordvariable(Qkeyarr0 As String, Qkeyarr1 As String, strin As String, filen As String) As String
Dim Qkey As String 'whether keywordvariable, keywordonly, keywordlist etc
Dim Qkeywordarr() As String 'separate content of Qkeyarr(1)
Dim Qword, tempword As Variant
Dim temp, temparr() As String
Dim Onfailure As String
Dim Onsuccess As String
Dim Fromdata As String
Dim i, rnum, rmax, relevance As Integer
Dim CouldAnswerCorrectly As Boolean
Dim Answertag, Answer, Ansformat(20) As String
Dim match As Integer
Dim Topic As String
Dim fileno As Integer
fileno = FreeFile
'Initialize
CouldAnswerCorrectly = False
Qkey = "[" + Qkeyarr0 + ":" + Qkeyarr1 + "]"

Qkeywordarr = Split(Qkeyarr1, ",")
For Each Qword In Qkeywordarr
'Remove \* in Qword
tempword = Trim(Replace(Qword, "\*", ""))
'-------------
    If InStr(strin, tempword) Then
       
        Open filen For Input As #fileno
        
        temp = ""
        'Move to the called tag in Qkey
        While Not temp = Qkey 'Go to that called tag
            Line Input #fileno, temp
        Wend
        
        'Get attributes of the tag keywordvariable
        While Not temp = ""
            Line Input #fileno, temp
            If Not temp = "" Then
                temparr = Split(temp, "=")
                Select Case temparr(0)
                Case "success"
                    Onsuccess = "[" + temparr(1) + "]"
                Case "failure"
                    Onfailure = "[" + temparr(1) + "]"
                Case "data"
                    Fromdata = "[" + temparr(1) + "]"
                Case Default
                End Select
            End If
        Wend
        
        ''''GET ANSWER'''''''''
        'Move to the tag in Fromdata
        While Not temp = Fromdata 'Go to that called tag
            Line Input #fileno, temp
        Wend
          
        'Check if Variable in question can be answered
        While Not temp = ""
            Line Input #fileno, temp
            If Not temp = "" Then
                temparr = Split(temp, "=")
                tempword = Replace(Qword, "\*", temparr(0))
                If InStr(strin, tempword) Then
                    Topic = temparr(0)
                    Answer = temparr(1)
                    CouldAnswerCorrectly = True
                    i = i + 1
                End If
            End If
        Wend
        
        'Check if you can answer or not
        If CouldAnswerCorrectly = True Then
            'If variable CAN be answered then goto tag in Onsuccess
            Answertag = Onsuccess
        Else
            'If variable CANNOT be answered then goto tag in Onfailure
            Answertag = Onfailure
        End If
        
        'Prepare answer
        While Not temp = Answertag 'Go to that called tag
            Line Input #fileno, temp
        Wend

        i = 0
        While Not temp = ""
            Line Input #fileno, temp
            If Not temp = "" Then
                Ansformat(i) = temp
                i = i + 1
            End If
        Wend
        
        rmax = i
        rnum = Int(rmax * Rnd)
        Close #fileno
        
        Answer = Replace(Ansformat(rnum), "%v", Answer)
        'Calculate Relevance
        If CouldAnswerCorrectly = True Then
            match = 10 'answer from response:success should have MORE weightage
        Else
            match = 1 'answer from response:failure should have LESS weightage
        End If
        
        relevance = CalculateRelevance(strin, Replace(Qword, "\*", Topic), match, Qkeyarr0, filen)
        
        'Write to tracefile
        Call AppendToTraceFile(Answer, relevance, strin, Qkey, Replace(Qword, "\*", Topic), Topic) 'Write to tracefile
        'Write to temporary optionfile
        Call AppendToOptionFile(Answer, relevance, strin, Qkey, Replace(Qword, "\*", Topic), Topic) 'Write to OPTIONFILE
    End If
            
'------------
Next Qword

AnalyseKeywordvariable = Answer ' Return the answer
End Function

''''''''''''
'Analyses strin with the Keyword/Keywordonly/keywordstart tag
''''''''''''
Function AnalyseKeywords(Qkeyarr0 As String, Qkeyarr1 As String, strin As String, filen As String) As String
Dim Qkey As String 'whether keywordvariable, keywordonly, keywordlist etc
Dim Qkeywordlistarr() As String 'separate content of Qkeyarr(1)
Dim Qkeywordarr() As String 'separate content of Qkeywordlistarr
Dim Qwordlist, Qword, strword, tempword, temp As Variant
Dim strArr() As String
Dim maxword, matchingwrdsinlst, matchingwrdsinprevlst, matchingwrds As Integer
Dim currpos, lastpos As Integer
Dim strlen, i, rnum, rmax, relevance As Integer
Dim CouldAnswerCorrectly As Boolean
Dim Answertag, Answer, Ansformat(20) As String
Dim strmatch, Topic As String
Dim KeyWithStars As String 'RHS containing the *'s
Dim fileno As Integer
fileno = FreeFile
'Initialize

strmatch = "" 'initialize

Qkey = "[" + Qkeyarr0 + ":" + Qkeyarr1 + "]"
strArr = Split(strin, " ") 'Store the words in strin
matchingwrdsinprevlst = 0

'Split each word list in Qkeyarr1 separated by,
Qkeywordlistarr = Split(Qkeyarr1, ",")
For Each Qwordlist In Qkeywordlistarr

    'code added on 8th Nov 2002 for star
    KeyWithStars = Qwordlist
    If Not InStr(Qwordlist, "*") = 0 Then
        If Left(Qwordlist, 1) = "*" Then Qwordlist = Right(Qwordlist, Len(Qwordlist) - 1)
        If Right(Qwordlist, 1) = "*" Then Qwordlist = Left(Qwordlist, Len(Qwordlist) - 1)
        Qwordlist = Trim(Replace(Qwordlist, "*", "|"))
    End If
    'end of code added on 8th Nove 2002 for star

matchingwrdsinlst = 0
maxword = 0
CouldAnswerCorrectly = False
'START SELECT-------------------------------------------------
Select Case Qkeyarr0 'Keywords
Case "keywordlistorder"
    'Split the wordlist in Qwordlist separated by |
    Qkeywordarr = Split(Qwordlist, "|")
    lastpos = 0
    For Each Qword In Qkeywordarr
        'Remove \* in Qword
        maxword = maxword + 1
        tempword = Trim(Replace(Qword, "\*", ""))
        '-------------
        If InStr(Trim(Qword), " ") = 0 Then 'this means that the Qwordlist contains only one word
            For Each strword In strArr
                If StrComp(Trim(strword), tempword) = 0 Then
                    'Count number of words in the list
                    'that match the user input in given order
                    currpos = InStr(strin, tempword)
                    If currpos > lastpos Then
                        matchingwrdsinlst = matchingwrdsinlst + 1
                        lastpos = currpos
                    End If
                End If
            Next strword
        Else
            If InStr(Trim(strin), Trim(Qword)) Then
                'Count number of words in the list match the user input
                currpos = InStr(strin, tempword)
                If currpos > lastpos Then
                    matchingwrdsinlst = matchingwrdsinlst + 1
                    lastpos = currpos
                End If
            End If
        End If
        '------------
    Next Qword

Case "keywordlist"
    'Split the wordlist in Qwordlist separated by |
    Qkeywordarr = Split(Qwordlist, "|")
    For Each Qword In Qkeywordarr
        'Remove \* in Qword
        maxword = maxword + 1
        tempword = Trim(Replace(Qword, "\*", ""))
        '-------------
        If InStr(Trim(Qword), " ") = 0 Then 'this means that the Qwordlist contains only one word
            For Each strword In strArr
                If StrComp(Trim(strword), Trim(tempword)) = 0 Then
                    'Count number of words in the list match the user input
                    matchingwrdsinlst = matchingwrdsinlst + 1
                End If
            Next strword
        Else
            If InStr(Trim(strin), Trim(Qword)) Then
                'Count number of words in the list match the user input
                matchingwrdsinlst = matchingwrdsinlst + 1
            End If
        End If
        'MsgBox Qwordlist & " " & machingwrdsinprevlst
        '------------
    Next Qword
    
Case "keywordonly"
    maxword = maxword + 1
    '-------------
    If StrComp(Trim(Qwordlist), strin) = 0 Then
        matchingwrdsinprevlst = matchingwrdsinprevlst + Len(Qwordlist)
        CouldAnswerCorrectly = True
    End If
    '------------
    
Case "keywordstart"
    maxword = maxword + 1
    strlen = Len(Qwordlist)
    '-------------
    If StrComp(Left(strin, strlen + 1), Trim(Qwordlist) & " ") = 0 Then
        'the white space after Qwordlist ensures that the match is a WORD
        matchingwrdsinprevlst = matchingwrdsinprevlst + strlen
        CouldAnswerCorrectly = True
    End If
    '------------
    
Case "keyword"
    maxword = maxword + 1
    strlen = Len(Qwordlist)
    '-------------
    If InStr(Trim(Qwordlist), " ") = 0 Then 'this means that the Qwordlist contains only one word
        For Each strword In strArr
            If StrComp(Trim(strword), Trim(Qwordlist)) = 0 Then
                'Count number of words in the list match the user input
                matchingwrdsinprevlst = matchingwrdsinprevlst + strlen
                CouldAnswerCorrectly = True
            End If
        Next strword
    Else
        If InStr(Trim(strin), Trim(Qwordlist)) Then
            'Count number of words in the list match the user input
            matchingwrdsinprevlst = matchingwrdsinprevlst + strlen
            CouldAnswerCorrectly = True
        End If
    End If
    '------------
Case Default
End Select
'END SELECT-------------------------------------------------

    'if any words in the wordlist are present
    'in the user input then get the answer
    'else not
    If Qkeyarr0 = "keywordlist" Or Qkeyarr0 = "keywordlistorder" Then
        'MsgBox matchingwrdsinlst & " " & maxword
        If matchingwrdsinlst > Int(0.75 * maxword) And matchingwrdsinlst <= maxword Then
            matchingwrdsinprevlst = matchingwrdsinlst
            CouldAnswerCorrectly = True
        End If
    End If
    
    If CouldAnswerCorrectly = True Then strmatch = KeyWithStars
Next Qwordlist
'------------------
'-rough topic of discussion
Topic = strmatch

If Not strmatch = "" Then
    Open filen For Input As #fileno
    temp = ""
    
    'Move to the called tag in Qkey
    While Not temp = Qkey 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''GET ANSWER'''''''''
    i = 0
    
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            Ansformat(i) = temp
            i = i + 1
        End If
    Wend
        
    'Prepare answer
    rmax = i
    rnum = Int(rmax * Rnd)
    Close #fileno
    
    Answer = Replace(Ansformat(rnum), "%v", Answer)
    'Calculate Relevance IMP NOTE :CalculateRelevance()
    'must be called before making changes in Qkeyarr0 variable
    matchingwrds = matchingwrdsinprevlst
    relevance = CalculateRelevance(strin, strmatch, matchingwrds, Qkeyarr0, filen)
    
    Call AppendToTraceFile(Answer, relevance, strin, Qkey, strmatch, Topic) 'Write to tracefile
    Call AppendToOptionFile(Answer, relevance, strin, Qkey, strmatch, Topic) 'Write to OPTIONFILE

Else
    Answer = ""
End If

'------------
AnalyseKeywords = Answer ' Return the answer
End Function

''''''''''''''''''''''''''''''''''''''''''''''
'Function to get answer from a specific keytag
''''''''''''''''''''''''''''''''''''''''''''''
Function GetAnswerFromKeyTag(ByVal keytag As String) As String
Dim i, rmax, rnum As Integer
Dim Ansformat(20) As String
Dim Answer, temp As String
Dim fileno As Integer

fileno = FreeFile
Open VariablesMod.CONFIGDATAFILE For Input As #fileno
    temp = ""
    
    'Move to the called tag in Qkey
    While Not Trim(temp) = keytag 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''GET ANSWER'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            Ansformat(i) = temp
            i = i + 1
        End If
    Wend
        
    'Prepare answer
    rmax = i
    rnum = Int(rmax * Rnd)
    Close #fileno

    Answer = Ansformat(rnum)
    GetAnswerFromKeyTag = Answer
End Function

Function NewAnalyzer(ByVal Qkeyarr0 As String, ByVal Qkeyarr1 As String, ByVal strin As String, ByVal filen As String) As String
Const cfStar = "<"
Const cfQ = ">"
Const cfWhiteSpace = ":"
Const cfSeparator = "#"
Dim keyArr() As String
Dim strinArr() As String
Dim WordsInKey() As String
Dim SplitAns() As String
Dim word, kword, sword, key, okey As Variant
Dim temp, temp1 As String
Dim berr As Boolean
Dim ki, si As Integer
On Error GoTo Fend
berr = True
'check for string validity
If InStr(key, cfSeparator) Or _
    InStr(key, cfStar) Or _
    InStr(key, cfQ) Or _
    InStr(key, cfWhiteSpace) Then GoTo Fend
    
'if there is a whitespace ahead or after the * or ?
'then delete it and then
'if there is a whitespace between two words
'then replace it with the whitespace character
okey = Qkeyarr1
okey = Replace(okey, " *", "*")
okey = Replace(okey, "* ", "*")
okey = Replace(okey, " ?", "?")
okey = Replace(okey, "? ", "?")
'okey = Replace(okey, " ", cfWhiteSpace)
key = okey
''''''''''''''''''''''''''''''''
'To split the case into an array
If Left(key, 1) = "*" Then key = cfStar & "|" & Right(key, Len(key) - 1)
If Left(key, 1) = "?" Then key = cfQ & "|" & Right(key, Len(key) - 1)
If Right(key, 1) = "*" Then key = Left(key, Len(key) - 1) & "|" & cfStar
If Right(key, 1) = "?" Then key = Left(key, Len(key) - 1) & "|#" & cfQ

key = Trim(Replace(key, "*", "|" & cfStar & "|"))
key = Trim(Replace(key, "?", "|" & cfQ & "|"))

key = Trim(Replace(key, cfStar, "*"))
key = Trim(Replace(key, cfQ, "?"))
key = Trim(Replace(key, "||", "|"))
key = Trim(Replace(key, cfWhiteSpace, " "))

keyArr = Split(key, "|")
'end of splitting case into array
''''''''''''''''''''''''''''''''
'now obtain the text words in key
temp = ""
For Each kword In keyArr
    If Not (kword = "*" Or kword = "?") Then
        temp = temp & kword & "|"
    End If
Next kword
temp = Left(temp, Len(temp) - 1) 'removes the last "|"
WordsInKey = Split(temp, "|")
'end of finding words in key
''''''''''''''''''''''''''''''''

'split the strin into different portions
temp = strin
temp1 = okey
For Each word In WordsInKey
    temp = Replace(temp, " " & Trim(word) & " ", "|")
    temp1 = Replace(temp1, " " & Trim(word) & " ", "|")
Next word

'SplitAns = Split(key, "|")
MsgBox temp & vbNewLine & temp1
'NewAnalyzer = key
berr = False
'error handling
Fend:
If berr = True Then MsgBox "Incorrect syntax in case " & Qkeyarr1 & " OR error processing " & Qkeyarr1 & vbNewLine & Err.Description
End Function
