Attribute VB_Name = "ParserMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
Function WriteResponse(str As String)
Parser.rtfDisplayBox.SelBold = True
Parser.rtfDisplayBox.SelColor = vbBlack
Parser.rtfDisplayBox.SelText = VariablesMod.CFGALIMbotNAME & " : "

Parser.rtfDisplayBox.SelBold = False
Parser.rtfDisplayBox.SelColor = vbBlack
Parser.rtfDisplayBox.SelText = str + vbNewLine
End Function

Function WriteInput(str As String)
Parser.rtfDisplayBox.SelBold = True
Parser.rtfDisplayBox.SelColor = vbBlue
Parser.rtfDisplayBox.SelText = VariablesMod.USERNAME & " : "

Parser.rtfDisplayBox.SelBold = False
Parser.rtfDisplayBox.SelColor = vbBlack
Parser.rtfDisplayBox.SelText = str + vbNewLine
End Function

Function IsQuestion(strin As String) As Boolean
If Not InStr(strin, "?") = 0 Then
    IsQuestion = True
Else
    IsQuestion = False
End If
End Function

Function GetConfiguration()
Dim temp As Variant
Dim arrstr() As String
Dim arrstr1() As String
Dim fileno As Integer
Dim eError As Boolean
eError = True
fileno = FreeFile
On Error GoTo Fend
Open VariablesMod.CONFIGDATAFILE For Input As #fileno
temp = ""

While Not Trim(temp) = "[general]"
    Line Input #fileno, temp
Wend

While Not EOF(fileno)
    Line Input #fileno, temp
    If temp = "" Then
        Close #fileno
        Exit Function
    End If
        
    arrstr = Split(temp, "=")
    Select Case Trim(arrstr(0))
    Case "name"
        VariablesMod.CFGALIMbotNAME = arrstr(1)
    Case "builddate"
        VariablesMod.CFGBUILDDATE = arrstr(1)
    Case "botmaster"
        VariablesMod.CFGBOTMASTER = arrstr(1)
    Case "logfile"
        arrstr1 = Split(arrstr(1), ",")
        
        If Trim(LCase(arrstr1(0))) = "on" Then
            VariablesMod.CFGCHATLOG = True
        Else
            VariablesMod.CFGCHATLOG = False
        End If
        
        VariablesMod.CURRCHATFILE = arrstr1(1)
    Case "tracefile"
        arrstr1 = Split(arrstr(1), ",")
        
        If Trim(LCase(arrstr1(0))) = "on" Then
            VariablesMod.CFGTRACELOG = True
        Else
            VariablesMod.CFGTRACELOG = False
        End If
        
        VariablesMod.TRACELOGFILE = arrstr1(1)
    Case "deadfile"
        arrstr1 = Split(arrstr(1), ",")
        
        If Trim(LCase(arrstr1(0))) = "on" Then
            VariablesMod.CFGDEADLOG = True
        Else
            VariablesMod.CFGDEADLOG = False
        End If
      
        VariablesMod.DEADLOGFILE = arrstr1(1)
    Case Default
    End Select
Wend

Close #fileno
eError = False

Fend:
If eError = True Then
    Call ErrH(eFileOpenErrorCritical, VariablesMod.CONFIGDATAFILE)
End If
End Function




'------------------------------
'Function to calculate the relevance of the answer found
'strin contains the user input
'matchstr() contains the matching query
'wordmatches contains the number of macthing words in strin and matchstr()
'ketstr contains the type of query [keywordvariable/keywordlist/keywordonly etc
'------------------------------
Function CalculateRelevance(strin As String, ByVal matchstr As String, wordmatches As Integer, keystr As String, filen As String) As Integer
Dim relevance As Integer

Select Case keystr
    Case "keywordonly"                          'Keyword Hierarchy
        relevance = 6000                        'keywordonly      ^
    Case "keywordvariable"                      'keywordvariable /|\
        relevance = 5000                        'keywordlistorder |
    Case "keywordlistorder"                     'keywordlist      |
        relevance = 4000 + Len(matchstr)        'keywordstart     |
    Case "keywordlist"                          'keyword          |
        relevance = 3000 + Len(matchstr)
    Case "keywordstart"
        relevance = 2100
    Case "keyword"
        relevance = 2000
    Case Default
        relevance = 0
End Select

'give a little higher relevance to the answer obtained from MEM file
'then for the same match in the dat file
If Not InStr(filen, ".mem") = 0 Then
    relevance = relevance + 2
End If
CalculateRelevance = relevance + wordmatches
End Function

Function AppendToTraceFile(ByVal ans As String, ByVal relevance As Integer, strin As String, ByVal key As String, ByVal strmatch As String, ByVal Topic As String)
Dim fileno As Integer
fileno = FreeFile
    'if trace option is ON in config/data file then
    'append else ignore the saving option
    If Trim(LCase(VariablesMod.TRACELOGFILE)) = "on" Then
        Open VariablesMod.TRACELOGFILE For Append As #fileno
            Print #fileno, Time() & ": R=" & relevance & ": OUTPUT IS " & ans & " FOR INPUT " & strin & " FROM " & key & " MATCH IS " & strmatch & "CHAT TOPIC IS " & Topic
        Close #fileno
    End If
End Function

Function AppendToOptionFile(ByVal ans As String, ByVal relevance As Integer, strin As String, ByVal key As String, ByVal strmatch As String, ByVal Topic As String)
Dim fileno As Integer
fileno = FreeFile
    Open VariablesMod.OPTIONFILE For Append As #fileno
        Print #fileno, relevance & "##" & strin & "##" & ans & "##" & key & "##" & strmatch & "##" & Topic
    Close #fileno
End Function


Function AppendToCurrChatFile(ByVal ans As String, strin As String)
Dim fileno As Integer
fileno = FreeFile
    Open VariablesMod.CURRCHATFILE For Append As #fileno
        Print #fileno, "(" & Time() & ") " & VariablesMod.USERNAME & " : " & strin
        Print #fileno, "(" & Time() & ") " & VariablesMod.CFGALIMbotNAME & " : " & ans
    Close #fileno
End Function

Function IsKeyTag(ByVal temp As String) As Boolean
Dim response As Boolean
If Left(temp, 1) = "[" Then
    response = True
Else
    response = False
End If
IsKeyTag = response
End Function

Function IsEmpty(ByVal temp As String) As Boolean
Dim response As Boolean
If temp = "" Then
    response = True
Else
    response = False
End If
IsEmpty = response
End Function

Function IsComment(ByVal temp As String) As Boolean
Dim response As Boolean
If Left(temp, 1) = "#" Then
    response = True
Else
    response = False
End If
IsComment = response
End Function

Function RepeatedInput(ByVal strin As String) As Boolean
Dim fileno As Integer
Dim arr() As String
Dim temp As String
Dim resp As Boolean
resp = False
fileno = FreeFile
Open VariablesMod.CURRCHATFILE For Input As #fileno
    While Not EOF(1)
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            arr = Split(Trim(temp), "##")
            If strin = arr(0) Then
                resp = True
            End If
        End If
    Wend
Close #fileno
RepeatedInput = resp
End Function

Function SaveChat()
On Error Resume Next
'Write Existing Chat file to dead.log
If VariablesMod.CFGDEADLOG = True Then
    Kill VariablesMod.DEADLOGFILE
    FileCopy VariablesMod.CURRCHATFILE, VariablesMod.DEADLOGFILE
    Kill VariablesMod.CURRCHATFILE
End If
'------------------
End Function

Function FindCurrTopic(ByVal rawTopic As String, ByVal strin As String, ByVal key As String, ByVal strmatch As String) As String
Dim keyArr() As String
Dim keytag As String
Dim no_key As Boolean
Dim Topic As String
no_key = True

Topic = ""
If InStr(key, ":") = 0 Or key = "" Then
    keytag = "" 'solve for default keytag
    no_key = True
Else
    keyArr = Split(key, ":")
    keytag = Right(keyArr(0), Len(keyArr(0)) - 1)
End If

Select Case keytag
    Case "keywordvariable"
            Topic = rawTopic
            no_key = False
    Case "keywordlistorder"
            rawTopic = Replace(rawTopic, "|", " ")
            Topic = DoDeleteCommonWords(rawTopic, VariablesMod.USELESSWORDFILE)
            no_key = False
    Case "keywordlist"
            rawTopic = Replace(rawTopic, "|", " ")
            Topic = DoDeleteCommonWords(rawTopic, VariablesMod.USELESSWORDFILE)
            no_key = False
    Case "keywordonly"
            Topic = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
            no_key = False
    Case "keywordstart"
            Topic = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
            no_key = False
    Case "keyword"
            Topic = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
            no_key = False
    Case Default
            '
End Select

If no_key = True Then 'for use in default case i.e. if no answer is obtained in dat file
    Topic = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
Else
    'if their is a key and still there is no topic
    'for example in the case of [keywordvariable:\*]
    If strmatch = "" And Topic = "" Then
        Topic = DoDeleteCommonWords(strin, VariablesMod.USELESSWORDFILE)
    End If
End If

If Topic = "" Then
    Topic = rawTopic
End If

FindCurrTopic = Topic
End Function

