Attribute VB_Name = "PostProcessingMod"
'#################################################################
'##           _      _____ __  __ _           _'
'##     /\   | |    |_   _|  \/  | |         | | ActiveX Control
'##    /  \  | |      | | | \  / | |__   ___ | |_
'##   / /\ \ | |      | | | |\/| | '_ \ / _ \| __|
'##  / ____ \| |____ _| |_| |  | | |_) | (_) | |_
'## /_/    \_\______|_____|_|  |_|_.__/ \___/ \__|
'##
'## Copyright (C) 2002-03, Mohammed Faizul Wahid
'##
'## This program is free software; you can redistribute it and/or
'## modify it under the terms of the GNU General Public License
'## as published by the Free Software Foundation; either version 2
'## of the License, or any later version.
'##
'## All copyright notices regarding ALIMBot ActiveX Control
'## must remain intact in the source code.
'##
'## This program is distributed in the hope that it will be useful,
'## but WITHOUT ANY WARRANTY; without even the implied warranty of
'## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'## GNU General Public License for more details.
'##
'## You should have received a copy of the GNU General Public
'## License along with this program; if not, write to the Free
'## Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
'## MA  02111-1307, USA.
'##
'## Support can be obtained from support forums at:
'## http://faizulwahid.tripod.com/alimbot/
'##
'## Correspondence and Questions can be sent to:
'## faiz_wahid@yahoo.com
'##
'#################################################################
Private Const CMDNAME = 1
Private Const CMDARG = 2
Private Const CMDQUOTE = 3

Private Const MAXSTAR = 10

Function DoPostProcessing(strin As String, Answer As String, strmatch As String, ByVal Topic As String) As String
Dim CmdArr() As String
'check if answer is a command
While Not InStr(Answer, "CMD::") = 0
    Answer = DoReplacePlugins(strin, Answer, strmatch, Topic)
    CmdArr = Split(Answer, "::")
    Select Case CmdArr(CMDNAME) 'which command?
        Case "RUNAPP"
            FunctionsMod.runapp (CmdArr(CMDARG))
            Answer = Replace(CmdArr(CMDQUOTE), "%c", CmdArr(CMDARG))
        Case "DOAGAIN"
            Answer = GetAnswerFromKeyTag(CmdArr(CMDQUOTE))
        Case "LOOKUPIN"
            Answer = Replace(CmdArr(CMDQUOTE), "%c", AnalyseKeywordLookupIn(strin, CmdArr(CMDARG)))
        Case "MATH"
            Answer = Replace(CmdArr(CMDQUOTE), "%c", DoMaths(CmdArr(CMDARG)))
        Case "SAVE"
            'MsgBox CmdArr(CMDARG)
            Call SaveData(CmdArr(CMDARG), USERNAME)
            Answer = CmdArr(CMDQUOTE)
        Case Default
            Answer = "There is some invalid command call in my data.dat file"
    End Select
Wend
Answer = DoReplacePlugins(strin, Answer, strmatch, Topic)
DoPostProcessing = Answer
End Function

Function DoReplacePlugins(strin As String, Answer As String, strmatch As String, ByVal Topic As String) As String

    Answer = DoPutStarValues(strin, strmatch, Answer)
    
    'REMEMBER if using two plugins of different lengths but
    'starting with the same letter then remember to
    'replace the longer length plugin before the shorter one
    Answer = Replace(Answer, "%d", Date) 'current date
    Answer = Replace(Answer, "%t", Time) 'current time
    Answer = Replace(Answer, "%b", VariablesMod.CFGBOTMASTER) 'botmaster name in data.dat
    Answer = Replace(Answer, "%a", VariablesMod.CFGBUILDDATE) 'build date in data.dat
    Answer = Replace(Answer, "%n", VariablesMod.CFGALIMbotNAME) 'ALIMbot name in data.dat
    Answer = Replace(Answer, "%u", VariablesMod.USERNAME) 'current user name
    Answer = Replace(Answer, "%li", VariablesMod.LASTINPUT) 'last user input
    Answer = Replace(Answer, "%lr", VariablesMod.LASTRESPONSE) 'last bot response
    'not implemented yet: can be obtained from the trace.log file
    'Answer = Replace(Answer, "%pi", VariablesMod.LASTINPUT) 'previous user input
    'Answer = Replace(Answer, "%pr", VariablesMod.LASTRESPONSE) 'previous bot response
    Answer = Replace(Answer, "%o", strin) 'original user input
    Answer = Replace(Answer, "%i", DoReplaceI2u(strin, strmatch, False)) 'inverted user input
    Answer = Replace(Answer, "%$", DoReplaceI2u(strin, strmatch, True)) 'matched pattern is removed and remaining string is inverted
    Answer = Replace(Answer, "%m", strmatch) 'matched pattern is subject of talk in keyword tag generally
    Answer = Replace(Answer, "%s", Topic) 'the current topic of discussion obtained from FindCurrTopic
    
    DoReplacePlugins = Answer
End Function

'function to replace "i" with "you" and etc
'specified in [replace] keytag
'for replacing the $ variable and remove the tag that matched the pattern
Function DoReplaceI2u(ByVal strout As String, ByVal strmatch As String, ByVal remove_matched_pattern As Boolean) As String
Dim replacearr() As String
Dim strinArr() As String
Dim temp As String
Dim word As Variant
Dim fileno As Integer
Dim max, i As Integer
Dim newstrout As String
Dim matchwith, replacewith As Integer

'remove the matched pattern from the input
If remove_matched_pattern = True Then
    strmatch = DoRemoveMultipleSpaces(Replace(strmatch, "\*", ""))
    'it is important to note that if strmatch is "i" then
    'by replacing strmatch all "i" letters in answer will be removed
    'hence if matched pattern contains more than 1 word then Replace
    'function is valid. Else we should split the words in strout and
    'then if the word matches it will be replaced
    If Not InStr(Trim(strmatch), " ") = 0 Then
        strout = DoRemoveMultipleSpaces(Replace(strout, strmatch, ""))
    Else
        strinArr = Split(Trim(strout), " ")

        max = -1
        For Each word In strinArr
            max = max + 1
        Next word
        
        For i = 0 To max
            If Trim(strinArr(i)) = Trim(strmatch) Then
                strinArr(i) = ""
            End If
        Next i
        strout = Join(strinArr)
        strout = DoRemoveMultipleSpaces(strout)
    End If
    'MsgBox strout
End If

newstrout = Trim(strout)
strinArr = Split(Trim(strout), " ")

max = -1
For Each word In strinArr
    max = max + 1
Next word

fileno = FreeFile

Open VariablesMod.CONFIGDATAFILE For Input As #fileno
    temp = ""
    'Move to the keytag [replace]
    While Not Trim(temp) = "[replace]" 'Go to that called tag
        Line Input #fileno, temp
    Wend
    
    ''''Replace in strin'''''''''
    i = 0
    While Not temp = ""
        Line Input #fileno, temp
        If Not (IsEmpty(temp) Or IsComment(temp) Or IsKeyTag(temp)) Then
            replacearr = Split(Trim(temp), "=")
            For matchwith = 0 To 1
                If matchwith = 0 Then replacewith = 1
                If matchwith = 1 Then replacewith = 0
                
                For i = 0 To max
                    If InStr(replacearr(matchwith), " ") = 0 Then 'ie only one word not wordS
                        If StrComp(Trim(strinArr(i)), Trim(replacearr(matchwith))) = 0 Then
                            strinArr(i) = "::" & replacewith & "::"
                        End If
                    Else
                        If InStr(Trim(strout), Trim(replacearr(matchwith))) Then
                            strout = Replace(strout, Trim(replacearr(matchwith)), Trim(Replace(replacearr(replacewith), " ", "::space::")))
                            strinArr = Split(strout, " ")
                        End If
                    End If
                Next i
            Next matchwith
            
            strout = Join(strinArr, " ")
            strout = Replace(strout, "::0::", replacearr(0))
            strout = Replace(strout, "::1::", replacearr(1))
            strout = Replace(strout, "::space::", " ")
            strinArr = Split(strout, " ")
        End If
    Wend
Close #fileno

newstrout = Join(strinArr, " ")
'MsgBox "|" & newstrout & "|"
DoReplaceI2u = newstrout
End Function


Function SaveData(ByVal str As String, ByVal uname As String)
Dim fileno1, fileno2 As Integer
Dim memfile, tempfile As String
Dim key As String
Dim ans As String
Dim arr() As String

arr = Split(Mid(Trim(str), 2, Len(str) - 2), ")(")

key = "[keywordlist:" & Replace(arr(0), " ", "|") & "]"
ans = arr(1)

memfile = VariablesMod.AMCDIR & "\" & uname & ".mem"
tempfile = App.Path & "\temp.txt"
fileno1 = FreeFile
'first check if this key already exists.
'if so either overwrite it or replace it with new info
Open memfile For Input As #fileno1
    fileno2 = FreeFile
    Open tempfile For Output As #fileno2
        While Not EOF(1)
            Line Input #fileno1, temp
            If IsKeyTag(temp) Then
                If Trim(temp) = key Then
                    While Not temp = ""
                        Line Input #fileno1, temp
                    Wend
                End If
            End If
            Print #fileno2, temp
        Wend
    Close #fileno2
Close #fileno1

'delete the existing memfile and copy tempfile to memfile
Kill (memfile)
FileCopy tempfile, memfile

fileno1 = FreeFile
Open memfile For Append As #fileno1
    Print #fileno1, vbNewLine
    Print #fileno1, key
    Print #fileno1, ans & vbNewLine
Close #fileno1
End Function

'Function to find values of stars
Private Function DoPutStarValues(ByVal strin As String, ByVal strmatch As String, ByVal Answer As String) As String
Dim StarArr(MAXSTAR) As String
Dim strmatchArr() As String
Dim temp As String
Dim word, nextword As Variant
Dim i, j As Integer
Dim starkey As String
Dim ItemsInArr, prevWordLoc, nextWordLoc, wdlen As Integer
Dim errvalue As Boolean
errvalue = True
On Error GoTo Fend

ItemsInArr = -1

'start of code for pipe and star combination
'to convert pipe-star combination into only star
strmatch = Trim(Replace(strmatch, "|", ""))
'end of code for pipe and star combination

If Left(strmatch, 1) = "*" Then strmatch = "#|" & Right(strmatch, Len(strmatch) - 1)
If Right(strmatch, 1) = "*" Then strmatch = Left(strmatch, Len(strmatch) - 1) & "|#"
strmatch = Trim(Replace(strmatch, "*", "|#|"))
strmatch = Trim(Replace(strmatch, "#", "*"))
strmatchArr = Split(strmatch, "|")

prevWordLoc = 1
nextWordLoc = 0

For Each word In strmatchArr
    ItemsInArr = ItemsInArr + 1
Next word

j = 0
i = 0

For i = 0 To ItemsInArr
    word = Trim(strmatchArr(i))

    If word = "*" Then
        If i = 0 Then prevWordLoc = 1
        If i > 0 And i <= ItemsInArr Then
            prevWordLoc = InStr(prevWordLoc, strin, strmatchArr(i - 1)) + Len(strmatchArr(i - 1)) + 1
        End If
        
        If i >= 0 And i < ItemsInArr Then
            nextWordLoc = InStr(prevWordLoc, strin, strmatchArr(i + 1))
        Else
            nextWordLoc = Len(strin) + 1
        End If
        
        temp = Mid(strin, prevWordLoc, nextWordLoc - prevWordLoc)
        StarArr(j) = Trim(temp)
        j = j + 1
        If j > MAXSTAR Then
            Call ErrH(eMaxStarOverflow, "Maximum Allowed stars (*) in a case are " & MAXSTAR & _
                ". Incorrect data in data file. ALIMbot output may have errors.")
            j = MAXSTAR
        End If
    End If
Next i

'Replace star values in the Answer
For i = 0 To j - 1
    starkey = "*" & i + 1
    Answer = Replace(Answer, starkey, StarArr(i))
Next i

errvalue = False

Fend:
If errvalue = True Then
    Answer = "It seems I have some internal problem. Better ask me some other time"
End If
DoPutStarValues = Answer
End Function

Private Function DoMaths(ByVal exp As String) As String
'write function to replace numbers in text...i.e. eight by 8 etc
'write function for calculation of expressions with +,-,/,x,^,% and more
'create a good supportive data file
exp = Replace(exp, "for", "4")
exp = Replace(exp, "to", "2")
DoMaths = exp
End Function
